#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>

using namespace std;

typedef vector<int> edges;
typedef vector<edges> graph;

int dfs(int x, const graph& g, vector<int>& used) {
    if (used[x] == 1)
        return 0;

    used[x] = 1;
    int result = 1;

    for (int i = 0; i < g[x].size(); ++i)
        result += dfs(g[x][i], g, used);

    return result;
}

void solve() {
    long long N, M, K;
    cin >> N >> M >> K;

    graph g;
    g.resize(N);

    for (int i = 0; i < M; ++i) {
        int x, y;
        cin >> x >> y;
        --x; --y;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    vector<int> components;
    vector<int> used;
    used.assign(N, 0);
    long long free = -M;

    for (int i = 0; i < N; ++i) if (used[i] == 0) {
        components.push_back(dfs(i, g, used));
        free += 1LL * components.back() * (components.back() - 1) / 2;
    }

    sort(components.begin(), components.end());
    reverse(components.begin(), components.end());

    int minimal = max((int)1, (int)(components.size() - K));
    int maximal = components.size();

    K -= free;
    long long sum = components[0];
    for (int i = 1; K > 0 && i < components.size(); ++i) {
        long long can_add = sum * components[i];
        K -= can_add;
        maximal -= 1;
        sum += components[i];
    }

    cout << minimal << ' ' << maximal << endl;
}

int main() {
    freopen("teedsis.txt", "r", stdin);
    freopen("teedval.txt", "w", stdout);

    solve();

    return 0;
}
